/*
 * Copyright (c) 1999 G. Adam Stanislav
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	mbm.c for utrans v.1
 */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

extern unsigned int utranstable[];

int main() {
	int c;
	int chars;
	unsigned int pagechar;
	unsigned int unichar;
	char buffer[9];

	c = 0;

	while (c != EOF) {
		c = fgetc(stdin);
		if ((c == '=') || ((c == '/') && (fgetc(stdin) == 'x'))) {
			for (chars = 0; chars < 2; chars++) {
				c = fgetc(stdin);
				if (isxdigit(c))
					buffer[chars] = c;
				else {
					ungetc(c, stdin);
					break;
				}
			}
			buffer[chars] = '\0';
			pagechar = strtoul(buffer, NULL, 16);
			for (;;) {
				c = fgetc(stdin);
				if (c == EOF)
					return EOF;
				else if (c == 'U') {
					c = fgetc(stdin);
					if (c != '+') {
						ungetc(c, stdin);
						if (!isxdigit(c)) continue;
					}

					for (chars = 0; chars < 8; chars++) {
						c = fgetc(stdin);
						if (isxdigit(c))
							buffer[chars] = c;
						else {
							ungetc(c, stdin);
							break;
						}
					}
					buffer[chars] = '\0';
					unichar = strtoul(buffer, NULL, 16);
					if (pagechar < 256)
						utranstable[pagechar] = unichar;
					else
						fprintf(stderr, "mbm: Ignoring invalid character %04x.\n", pagechar);
					break;
				}
			}
		}
	}
	fwrite(utranstable, sizeof(unsigned int), 256, stdout);
	return 0;
}